#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
# grabslides : multipurpose frame grabber
#
# (c) 2005-2009 Jerome Alet <alet@librelogiciel.com>
# (c) 2009 University of New-Caledonia
# (c) 2005, 2006 Faculty of Medecine, University of Nice-Sophia Antipolis
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
#
#

"""This module defines the class for X window frame grabbers."""

import urllib2
import urlparse

import pygst
pygst.require("0.10")
import gst

from grabslides import framegrabber

class FrameGrabber(framegrabber.BaseFrameGrabber) :
    """A class to grab frames from an X server."""
    def __init__(self, parent, url, every, threshold) :
        """Initializes the frame grabber."""
        if url.startswith("x://") :
            parts = urllib2.urlparse.urlsplit(url.replace("x://", "http://"))
            try :
                screen = int(parts[1])
            except (IndexError, TypeError, ValueError) :
                raise ValueError, "Incorrect screen number in parameter '%(url)s' for X frame grabber." % locals()
            source = 'ximagesrc screen-num="%(screen)i" ! video/x-raw-rgb,framerate=(fraction)1/1,pixel-aspect-ratio=(fraction)1/1 ! queue' % locals()
            framegrabber.BaseFrameGrabber.__init__(self, parent,
                                                         url,
                                                         every,
                                                         threshold,
                                                         source)
        else :
            raise ValueError, "Incorrect parameter '%(url)s' for X frame grabber." % locals()
