#! /usr/bin/env python
# -*- coding: utf-8 -*-
#
# grabslides : multipurpose frame grabber
#
# (c) 2005-2009 Jerome Alet <alet@librelogiciel.com>
# (c) 2009 University of New-Caledonia
# (c) 2005, 2006 Faculty of Medecine, University of Nice-Sophia Antipolis
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# $Id: setup.py 25 2009-08-18 03:46:20Z jerome $
#
#

import sys
import glob
import os
import imp
import shutil
try :
    from distutils.core import setup
except ImportError, msg :
    sys.stderr.write("%s\n" % msg)
    sys.stderr.write("You need the DistUtils Python module.\nunder Debian, you may have to install the python-dev package.\nOf course, YMMV.\n")
    sys.exit(-1)

version = imp.load_source("version", os.path.join("grabslides", "version.py"))

data_files = []
docdir = "share/doc/grabslides"
docfiles = ["README", "COPYING", "AUTHORS"]
if os.path.exists("ChangeLog") :
    docfiles.append("ChangeLog")
data_files.append((docdir, docfiles))

directory = os.sep.join(["share", "man", "man1"])
manpages = glob.glob(os.sep.join(["man", "*.1"]))
data_files.append((directory, manpages))

setup(name = "grabslides", version = version.__version__,
      license = version.__license__,
      description = version.__doc__,
      author = version.__author__,
      author_email = version.__authoremail__,
      url = version.__url__,
      packages = [ "grabslides", "grabslides.framegrabbers" ],
      scripts = [ "bin/grabslides" ],
      data_files = data_files)
